import { NotPromise, AnyObject, SoundType } from './global';
declare type SoundTypeArray<T> = T extends SoundType ? T[] : [];
declare class Is {
    get not(): IsNot;
    null(value: unknown): value is null;
    null<T>(value: unknown, defaultValue: () => T): T;
    function<T extends Function>(value: T): value is T;
    function<T extends Function = Function>(value: unknown): value is T;
    array<T>(value: T | T[]): value is SoundTypeArray<T>;
    array<T>(value: unknown): value is T[];
    promise<T>(value: Promise<T>): value is Promise<T>;
    promise<T = unknown>(value: unknown): value is Promise<NotPromise<T>>;
    keyValuePair(value: unknown): boolean;
    object<T extends object>(value: T): value is T;
    object<T extends object = object>(value: unknown): value is T;
    plainObject<T extends object>(value: T): value is T;
    plainObject<T extends object = object>(value: unknown): value is T;
    date(value: unknown): value is Date;
    date(value: unknown, defaultValue: Date): Date;
    boolean(value: unknown): value is boolean;
    string(value: unknown): value is string;
    empty(value: unknown): boolean;
    error(value: AnyObject): value is Error;
    number(value: unknown): value is number;
    enum(value: any, enumDefinition: object): boolean;
    primitive<T extends string | number | boolean>(value: T): value is T;
}
declare class IsNot {
    null<T>(value: T): value is T;
    null<T>(value: unknown, defaultValue: () => T): T;
    allNull<T>(...values: (() => T)[]): T | undefined;
    empty(value: unknown): value is string;
    empty(...values: unknown[]): boolean;
    object(value: unknown): boolean;
}
export declare const is: Is;
export {};
