import { AnyObject } from '../extensions/global';
export declare enum LogTypes {
    Debug = 0,
    Info = 1,
    Warn = 2,
    Error = 3
}
export declare namespace LogTypes {
    function getName(type: LogTypes): string;
    function fromName(type: string): LogTypes;
    function getColor(type: LogTypes): "redBright" | "yellow" | "white" | "gray";
    function getMethod(type: LogTypes): "error" | "warn" | "info" | "log";
}
interface Props {
    category: string;
    level: LogTypes;
}
export declare class Logger {
    #private;
    constructor(props: Props);
    debug(message: string, data?: AnyObject): void;
    info(message: string, data?: AnyObject): void;
    warn(message: string, data?: AnyObject): void;
    error(message: string, data?: AnyObject): void;
    error(error: Error, data?: AnyObject): void;
    ofType(type: LogTypes, message: string, data?: AnyObject): void;
    private process;
    private formatMessage;
}
export {};
